unit UAction;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ImgList, ExtCtrls, ShellAPI, Math, Registry,
  IniFiles, UMain, UKeybEmul, UVarDef;

type
  TActionForm = class(TForm)
    PageControl: TPageControl;
    KeybTs: TTabSheet;
    ExecTs: TTabSheet;
    VolumeTs: TTabSheet;
    VariableTs: TTabSheet;
    MiscTs: TTabSheet;
    IconList: TImageList;
    OkBtn: TButton;
    CancelBtn: TButton;
    KeyCombo: TComboBox;
    ModifiersLbl: TLabel;
    CtrlCb: TCheckBox;
    ShiftCb: TCheckBox;
    AltCb: TCheckBox;
    WindowsCb: TCheckBox;
    PathLbl: TLabel;
    PathEdt: TEdit;
    BrowseBtn: TButton;
    FirstTryCb: TCheckBox;
    GroupBox1: TGroupBox;
    CloseRb: TRadioButton;
    ActivateRb: TRadioButton;
    MixerLbl: TLabel;
    DestLbl: TLabel;
    DeviceCombo: TComboBox;
    LineCombo: TComboBox;
    MuteRb: TRadioButton;
    UpRb: TRadioButton;
    DownRb: TRadioButton;
    VolTb: TTrackBar;
    VarNameLbl: TLabel;
    VarNameCombo: TComboBox;
    DefineVarBtn: TButton;
    VarLoopUpRb: TRadioButton;
    SetValueRb: TRadioButton;
    VarValueCombo: TComboBox;
    OpenDialog: TOpenDialog;
    KeyLbl: TLabel;
    RadioGroup1: TRadioGroup;
    ExecClassRb: TRadioButton;
    ExecClassCombo: TComboBox;
    ExecFormCombo: TComboBox;
    ExecFormRb: TRadioButton;
    ExecRefreshBtn: TButton;
    KeybClassRb: TRadioButton;
    KeybClassCombo: TComboBox;
    KeybFormCombo: TComboBox;
    KeybFormRb: TRadioButton;
    KeybTargetLbl: TLabel;
    KeybActiveWindowRb: TRadioButton;
    KeybRefreshBtn: TButton;
    VarLoopDnRb: TRadioButton;
    MiscSb: TScrollBox;
    Panel1: TPanel;
    OSDRb: TRadioButton;
    OSDCombo: TComboBox;
    MoreTVCombo: TComboBox;
    MoreTVRb: TRadioButton;
    KTVRb: TRadioButton;
    KTVCombo: TComboBox;
    WinampCombo: TComboBox;
    WinampRb: TRadioButton;
    MediaPlayerRb: TRadioButton;
    MediaPlayerCombo: TComboBox;
    BsPlayerCombo: TComboBox;
    BsPlayerRb: TRadioButton;
    PowerDVDRb: TRadioButton;
    WinSTBRb: TRadioButton;
    WinSTBCombo: TComboBox;
    PowerDVDCombo: TComboBox;
    ContactLbl: TLabel;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FirstTryCbClick(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure BrowseBtnClick(Sender: TObject);
    procedure ComboChange(Sender: TObject);
    procedure DeviceComboChange(Sender: TObject);
    procedure DefineVarBtnClick(Sender: TObject);
    procedure VarNameComboChange(Sender: TObject);
    procedure VarValueComboChange(Sender: TObject);
    procedure MiscComboChange(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure RefreshVariables;
    procedure ApplyLanguage(Lang: string);
  end;

var
  ActionForm: TActionForm;

const
  NBOSDOPT = 4;
  OSDOPT: array[0..NBOSDOPT - 1] of string =
  ('Current time', 'Clock on/off', 'Current date', 'Foreground window name');
  NBMORETVOPT = 27;
{  MORETVOPT: array[0..NBMORETVOPT - 1] of string =
  ('stop/start video and sound (ESC)', 'show help (F1)', 'decryption on/off/auto (F2)',
    'to foreground on/off (F3)', 'set colour, contrast, brightness, volume (F4)',
    'Decrease Edge (F5)', 'Increase Edge (F6)', 'Automatic Edges (F7)',
    'Dialogue Window: Decoder Test Lines (F8)', 'full-screen on/off (F9)',
    'close MoreTV (F10)', 'turbo/standard decoder (F11)', 'Colorphase (F12)',
    'channel plus (+)', 'channel minus (-)', 'station1 (1)', 'station2 (2)',
    'station3 (3)', 'station4 (4)', 'station5 (5)', 'station6 (6)',
    'station7 (7)', 'station8 (8)', 'station9 (9)', 'station10 (0)',
    'station plus (UP)', 'Station minus (DOWN)');}
  MORETVOPT_KEY: array[0..NBMORETVOPT - 1] of Integer = (VK_ESCAPE, VK_F1, VK_F2,
    VK_F3, VK_F4, VK_F5, VK_F6, VK_F7, VK_F8, VK_F9, VK_F10, VK_F11, VK_F12,
    VK_ADD, VK_SUBTRACT, VK_NUMPAD1, VK_NUMPAD2, VK_NUMPAD3, VK_NUMPAD4, VK_NUMPAD5,
    VK_NUMPAD6, VK_NUMPAD7, VK_NUMPAD8, VK_NUMPAD9, VK_NUMPAD0, VK_UP, VK_DOWN);
  NBKTVOPT = 51;
{  KTVOPT: array[0..NBKTVOPT - 1] of string =
  ('chanel 0', 'chanel 1', 'chanel 2', 'chanel 3', 'chanel 4',
    'chanel 5', 'chanel 6', 'chanel 7', 'chanel 8', 'chanel 9',
    'show infos', 'freeze', 'Channel list / teletext home', 'teletext',
    'channel +', 'channel -', 'toggle deinterlace', 'reset tuner',
    'zoom 16/9, 20/9, default', 'black strip 20/9', 'black strip 16/9',
    'black strip disable', 'black strip +', 'black strip -', 'fullscreen',
    'black strip auto', 'volume +', 'volume -', 'toggle subtitles',
    'color +', 'color -', 'brightness +', 'brightness -', 'contrast +',
    'contrast -', 'mute', 'balance left', 'balence right', 'teletext page -',
    'teletext page +', 'teletext page up', 'teletext page down', 'close',
    'close K!TV and Windows', 'composite', 's-video', 'composite via s-video',
    'video plugin on', 'video plugin off', 'force video plugin', 'plugin audio');}
  KTVOPT_PARAM: array[0..NBKTVOPT - 1] of Integer =
  (VK_NUMPAD0, VK_NUMPAD1, VK_NUMPAD2, VK_NUMPAD3, VK_NUMPAD4, VK_NUMPAD5, VK_NUMPAD6,
    VK_NUMPAD7, VK_NUMPAD8, VK_NUMPAD9, 132, 232, 242, 245, 266, 267, 271, 280, 282,
    290, 291, 292, 298, 299, 320, 366, 374, 375, 383, 394, 395, 396, 397, 398, 399,
    402, 403, 404, 417, 418, 419, 420, 1032, 1033, 1090, 1091, 1092, 40001, 40002,
    40003, 40005);
  NBWINAMPOPT = 9;
{  WINAMPOPT: array[0..NBWINAMPOPT - 1] of string =
  ('prev track (Z)', 'play (X)', 'pause (C)', 'stop (V)',
    'next track (B)', 'rewind (5 sec.)', 'forward (5 sec.)',
    'volume down', 'volume up');}
  WINAMPOPT_KEY: array[0..NBWINAMPOPT - 1] of Integer =
  (Ord('Z'), Ord('X'), Ord('C'), Ord('V'), Ord('B'), VK_LEFT, VK_RIGHT, VK_DOWN, VK_UP);
  NBWMPOPT = 12;
{  WMPOPT: array[0..NBWMPOPT - 1] of string =
  ('play/pause (Ctrl + P)', 'stop (Ctrl + S)', 'previous (Ctrl + B)', 'next (Ctrl + F)',
    'rewind (Ctrl + Shift + B)', 'fast forward (Ctrl + Shift + F)', 'shuffle (Ctrl + H)',
    'repeat (Ctrl + T)', 'mute (F8)', 'volume down (F9)', 'volume up (F10)',
    'Fullscreen (Alt + Enter)');}
  WMPOPT_PARAM: array[0..NBWMPOPT - 1] of Integer =
  (32808, 32809, 32810, 32811, 32812, 32813, 32842, 32843, 32817, 32816, 32815, 98318);
  NBBSPLAYOPT = 45;
{  BSPLAYOPT: array[0..NBBSPLAYOPT - 1] of string =
  ('Volume up (Up)', 'Volume down (Down)', 'Seek backward (Left)', 'Seek forward (Right)',
    'Open... (L)', 'Open audio file (Shift + L)', 'Load subtitles (Ctrl + L)',
    'Subtitles on/off (S)', 'Full screen switch (F)', 'Pan-scan (O)',
    'Custom Pan-scan (Shift + O)', 'Always On Top (Ctrl + A)', 'Prev (Z)',
    'Play (X)', 'Pause (C)', 'Stop (V)', 'Next (B)', 'Prev chapter (Ctrl + Z)',
    'Next chapter (Ctrl + B)', 'Prev CD (Shift + Z)', 'Next CD (Shift + B)',
    'Capture frame - original image size (P)', 'Capture frame - "What you see" (Shift + P)',
    'Subtitles time correction - (Ctrl + Left)', 'Subtitles time correction + (Ctrl + Right)',
    'Subtitles time correction + [small steps] (Shift + Left)', 'Subtitles time correction - [small steps] (Shift + Right)',
    'Mute (Ctrl + M)', 'Jump to time (Ctrl + J)', 'Zoom in (+)', 'Zoom out (-)',
    'Zoom 50% (1)', 'Zoom 100% (2)', 'Zoom 200% (3)', 'Aspect ratio original (Shift + 1)',
    'Aspect ratio 16:9 (Shift + 2)', 'Aspect ratio 4:3 (Shift + 3)', 'Cycle aspect ratios (A)',
    'Show/Hide main window (H)', 'Add bookmark (Alt + I)', 'Move picture left (Num 4)',
    'Move picture right (Num 6)', 'Move picture up (Num 8)', 'Move picture down (Num 2)',
    'Reset Zoom & Move (Num 5)');}
  BSPLAYOPT_KEY: array[0..NBBSPLAYOPT - 1] of Integer = (
    VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT, Ord('L'), Ord('L'), Ord('L'), Ord('S'),
    Ord('F'), Ord('O'), Ord('O'), Ord('A'), Ord('Z'), Ord('X'), Ord('C'),
    Ord('V'), Ord('B'), Ord('Z'), Ord('B'), Ord('Z'), Ord('B'), Ord('P'),
    Ord('P'), VK_LEFT, VK_RIGHT, VK_LEFT, VK_RIGHT, Ord('M'), Ord('J'),
    VK_ADD, VK_SUBTRACT, Ord('1'), Ord('2'), Ord('3'), Ord('1'), Ord('2'),
    Ord('3'), Ord('A'), Ord('H'), Ord('I'), VK_NUMPAD4, VK_NUMPAD6, VK_NUMPAD8,
    VK_NUMPAD2, VK_NUMPAD5);
  BSPLAYOPT_SHIFT: array[0..NBBSPLAYOPT - 1] of string[3] = (//alt, ctrl, shift
    '000', '000', '000', '000', '000', '001', '010', '000', '000', '000', '001',
    '010', '000', '000', '000', '000', '000', '010', '010', '001', '001', '000',
    '001', '010', '010', '001', '001', '010', '010', '000', '000', '000', '000',
    '000', '001', '001', '001', '000', '000', '100', '000', '000', '000', '000',
    '000');
  NBPDVDOPT = 26;
{  PDVDOPT: array[0..NBPDVDOPT - 1] of string = (
    'Play (Enter)', 'Pause (Space)', 'Stop (S)', 'Previous (P)', 'Next (N)', 'Step backward (Ctrl + B)', 'Step Forward (T)',
    'Increase volume (+)', 'Mute (Q)', 'Decrease volume (-)', 'Minimizes user interface to taskbar (Ctrl + N)',
    'Exits PowerDVD (Ctrl + X)', 'Accesses online help (F1)', 'Displays information about PowerDVD (Ctrl + A)',
    'i-Power (F3)', 'Capture frame (C)', 'Go up (R)', 'Switches audio stream (H)',
    'Switches subtitles (U)', 'Menu (L)', 'Full Screen (Z)', 'Configuration (Ctrl + C)',
    'Eject (Ctrl + E)', 'Select Source (Ctrl + O)', 'Skin Toggle (Ctrl + T)',
    'Activates/inactivates Menu/Number Pad (/)');}
  PDVDOPT_KEY: array[0..NBPDVDOPT - 1] of Integer = (
    VK_RETURN, VK_SPACE, Ord('S'), Ord('P'), Ord('N'), Ord('B'), Ord('T'),
    VK_ADD, Ord('Q'), VK_SUBTRACT, Ord('N'), Ord('X'), VK_F1, Ord('A'), VK_F3, Ord('C'),
    Ord('R'), Ord('H'), Ord('U'), Ord('L'), Ord('Z'), Ord('C'), Ord('E'), Ord('O'),
    Ord('T'), VK_DIVIDE);
  PDVDOPT_CTRL: array[0..NBPDVDOPT - 1] of Boolean = (
    False, False, False, False, False, True, False, False, False, False, True,
    True, False, True, False, False, False, False, False, False, False, True,
    True, True, True, False);
  NBWINSTBOPT = 27;
{  WINSTBOPT: array[0..NBWINSTBOPT - 1] of string = (
    'Channel 1 (1)', 'Channel 2 (2)', 'Channel 3 (3)', 'Channel 4 (4)', 'Channel 5 (5)',
    'Channel 6 (6)', 'Channel 7 (7)', 'Channel 8 (8)', 'Channel 9 (9)', 'Channel 0 (0)',
    'Red (F1)', 'Green (F2)', 'Yellow (F3)', 'Blue (F4)', 'Show Remote (F5)',
    'Back (Backspace)', 'Menu (Spacebar)', 'Up (Up)', 'Down (Down)', 'Left (Left)',
    'Right (Right)', 'Ok (Enter)', 'Volume + (+)', 'Volume - (-)', 'Prog + (PageUp)',
    'Prog - (PageDown)', 'RCL (Home)');}
  WINSTBOPT_KEY: array[0..NBWINSTBOPT - 1] of integer = (
    Ord('1'), Ord('2'), Ord('3'), Ord('4'), Ord('5'), Ord('6'), Ord('7'), Ord('8'),
    Ord('9'), Ord('0'), VK_F1, VK_F2, VK_F3, VK_F4, VK_F5, VK_BACK, VK_SPACE, VK_UP,
    VK_DOWN, VK_LEFT, VK_RIGHT, VK_RETURN, VK_ADD, VK_SUBTRACT, VK_PRIOR,
    VK_NEXT, VK_HOME);
  {NBANOTHERPROGOPT = 2;
  ANOTHERPROGOPT: array[0..NBANOTHERPROGOPT - 1] of string = (
    '...', '...');
  ANOTHERPROGOPT_KEY: array[0..NBANOTHERPROGOPT - 1] of integer = (
    0, 0);}

var
  MORETVOPT: array[0..NBMORETVOPT - 1] of string;
  KTVOPT: array[0..NBKTVOPT - 1] of string;
  WINAMPOPT: array[0..NBWINAMPOPT - 1] of string;
  WMPOPT: array[0..NBWMPOPT - 1] of string;
  BSPLAYOPT: array[0..NBBSPLAYOPT - 1] of string;
  PDVDOPT: array[0..NBPDVDOPT - 1] of string;
  WINSTBOPT: array[0..NBWINSTBOPT - 1] of string;

procedure ExecuteSingleAction(Act: PSingleAction);

implementation

{$R *.dfm}

//------------------------------------------------------------------------------

procedure ReadMoreTVStation;
begin
  with TRegistry.Create do
  try
    if OpenKeyReadOnly('Software\Feuerstein\MoreTV') then
    begin
      Variables.GetVarFromName('Station MoreTV').Value := ReadInteger('Programmplatz') - 1;
      CloseKey;
    end;
  except
    Free;
  end;
end;

//------------------------------------------------------------------------------

function GetForegroundName: string;
var
  Str: string;
  AHandle: HWND;
  PCharResult: PChar;
  TextLength: Integer;
begin
  AHandle := GetForegroundWindow;
  if Ahandle <> NULL_HANDLE then
  begin
    TextLength := GetWindowTextLength(AHandle) + 1;
    if TextLength > 1 then
    begin
      GetMem(PCharResult, TextLength);
      GetWindowText(AHandle, PCharResult, TextLength);
      Str := string(PCharResult) + ' ';
      Freemem(PCharResult);
    end
    else Str := '';
    GetMem(PCharResult, 255);
    GetClassName(AHandle, PCharResult, 255);
    Str := Str + '{' + string(PCharResult) + '}';
    Freemem(PCharResult);
  end;
  Result := Str;
end;

//------------------------------------------------------------------------------

procedure ExecuteSingleAction(Act: PSingleAction);
var
  I: Integer;
  Str: string;
  AHandle: HWnd;
  L, R, M: Integer;
  VD, MD: Boolean;
  Stereo: Boolean;
  NewVol: Integer;
begin
  case Act.ActionType of
    //keyborad emulation
    atKeyb: with Act.KeybData^ do
      begin
        Str := Target;
        case TargetType of
          ttClass: AHandle := FindWindow(PChar(Str), nil);
          ttForm: AHandle := FindWindow(nil, PChar(Str));
          else AHandle := NULL_HANDLE;
        end;
        KeyboardEmulation(AHandle, Ord(Ch), Alt, Ctrl, Shift, Windows);
      end;
    //misc action
    atMisc: with Act.MiscData^ do
      begin
        case Category of
          //osd
          OSD_CAT:
            case Value of
              0: ShowOSD(copy(TimeToStr(Time), 1, 5));
              1: ShowOSD('#Clock#');
              2: ShowOSD(DateToStr(Date));
              3: ShowOSD(GetForegroundName);
            end;
          //moretv
          MORETV_CAT: begin
              AHandle := FindWindow(PChar('MoreTV'), nil);
              if AHandle <> NULL_HANDLE then
              begin
                PostMessage(AHandle, WM_KEYDOWN, MORETVOPT_KEY[Value], 0);
                PostMessage(AHandle, WM_KEYUP, MORETVOPT_KEY[Value], 0);
              end;
            end;
          //k!tv
          KTV_CAT: begin
              AHandle := FindWindow(PChar('K!TV XP'), nil);
              if AHandle <> NULL_HANDLE then
                if Value < 10 then
                  PostMessage(AHandle, WM_KEYUP, KTVOPT_PARAM[Value], 0)
                else PostMessage(AHandle, WM_COMMAND, KTVOPT_PARAM[Value], 0);
            end;
          //winamp
          WINAMP_CAT: begin
              AHandle := FindWindow(PChar('STUDIO'), nil);
              if AHandle = NULL_HANDLE then AHandle := FindWindow(PChar('Winamp v1.x'), nil);
              if AHandle = NULL_HANDLE then AHandle := FindWindow(PChar('BaseWindow_RootWnd'), nil);
              if AHAndle <> NULL_HANDLE then
              begin
                PostMessage(AHandle, WM_KEYDOWN, WINAMPOPT_KEY[Value], 0);
                PostMessage(AHandle, WM_KEYUP, WINAMPOPT_KEY[Value], 0);
              end;
            end;
          //Windows Media Player
          MEDIAPLAYER_CAT: begin
              AHandle := FindWindow(PChar('WMPlayerApp'), nil);
              if AHAndle <> NULL_HANDLE then
                PostMessage(AHandle, WM_COMMAND, WMPOPT_PARAM[Value], 0);
            end;
          //BSPlayer
          BSPLAYER_CAT: begin
              AHandle := FindWindow(PChar('BSPlayer'), nil);
              if AHAndle <> NULL_HANDLE then
                KeyboardEmulation(AHandle, BSPLAYOPT_KEY[Value], BSPLAYOPT_SHIFT[Value][1] = '1', BSPLAYOPT_SHIFT[Value][2] = '1', BSPLAYOPT_SHIFT[Value][3] = '1');
            end;
          //Power DVD
          PowerDVD_CAT: begin
              AHandle := FindWindow(nil, PChar('PowerDVD'));
              if AHAndle <> NULL_HANDLE then
                KeyboardEmulation(AHandle, PDVDOPT_KEY[Value], False, PDVDOPT_CTRL[Value]);
            end;
          //WinSTB
          WINSTB_CAT: begin
              AHandle := FindWindow(PChar('TSoftOSDForm'), nil);
              if AHAndle <> NULL_HANDLE then
              begin
                PostMessage(AHandle, WM_KEYDOWN, WINSTBOPT_KEY[Value], 0);
                PostMessage(AHandle, WM_KEYUP, WINSTBOPT_KEY[Value], 0);
              end;
            end;
          //AnotherProg
          {ANOTHERPROG_CAT: begin
              AHandle := FindWindow(PChar('AnotherProg'), nil);
              if AHAndle <> NULL_HANDLE then
              begin
                PostMessage(AHandle, WM_KEYDOWN, ANOTHERPROGOPT_KEY[Value], 0);
                PostMessage(AHandle, WM_KEYUP, ANOTHERPROGOPT_KEY[Value], 0);
              end;
            end;}
        end;
      end;
    //execute program
    atExec: with Act.ExecData^ do
      begin
        if FirstClose <> ttNone then
        begin
          AHandle := SearchTarget(FirstTarget, FirstClose);
          if AHandle <> NULL_HANDLE then
            PostMessage(AHandle, WM_CLOSE, 0, 0);
        end
        else if FirstActivate <> ttNone then
        begin
          AHandle := SearchTarget(FirstTarget, FirstActivate);
          if AHandle <> NULL_HANDLE then
            SetForegroundWindow(AHandle);
        end
        else AHandle := NULL_HANDLE;
        if AHandle = NULL_HANDLE then
        begin
          Str := Path;
          //special case MORETV
          if SameText(ExtractFileName(Str), 'MoreTV.exe') and (Variables.GetVarFromName('Station MoreTV') <> nil) then
            ReadMoreTVStation;
          ShellExecute(0, 'open', PChar(Str), nil, nil, SW_SHOWNORMAL);
        end;
      end;
    //change volume
    atAMix: with Act.AMixData^ do
      begin
        if Mute then
        begin
          AMixer.GetMute(Device, Line - 1, MD);
          AMixer.SetMute(Device, Line - 1, not (MD));
        end
        else begin
          AMixer.GetVolume(Device, Line - 1, L, R, M, Stereo, VD, MD);
          NewVol := Max(Min((L + R) div 2 + Vol, 65535), 0);
          AMixer.SetVolume(Device, Line - 1, NewVol, NewVol, -1);
        end;
      end;
    //change variable
    atCVar: with Act.CVarData^ do
        for I := 0 to Variables.Count - 1 do
          if Variables[I].Name = VarName then
            with Variables[I]^ do
            begin
              if Loop = LOOP_UP then
                if Value = Values.Count - 1 then
                  Value := 0
                else Inc(Value)
              else if Loop = LOOP_DOWN then
                if Value = 0 then
                  Value := Values.Count - 1
                else Dec(Value)
              else Value := SetValue;
              Break;
            end;
  end;
end;

//------------------------------------------------------------------------------

procedure TActionForm.RefreshVariables;
var
  I: Integer;
begin
  VarNameCombo.Clear;
  for I := 0 to Variables.Count - 1 do
    VarNameCombo.Items.Add(Variables[I].Name);
  if VarNameCombo.Items.Count > 0 then
  begin
    VarNameCombo.ItemIndex := 0;
    VarNameComboChange(nil);
  end;
end;

//------------------------------------------------------------------------------

procedure TActionForm.ApplyLanguage(Lang: string);
var
  I: Integer;
begin
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.lang')) do
  try
    Self.Caption := ReadString(Lang, 'ActionTitle', 'Action');
    PageControl.Pages[0].Caption := ReadString(Lang, 'EmulKeybEventTitle', 'Emulate keyboard event');
    KeyLbl.Caption := ReadString(Lang, 'KeyCaption', 'Key :');
    ModifiersLbl.Caption := ReadString(Lang, 'ModifiersCaption', 'Modifiers :');
    KeybTargetLbl.Caption := ReadString(Lang, 'TargetCaption', 'Target :');
    KeybActiveWindowRb.Caption := ReadString(Lang, 'ActiveWindowCaption', 'Active window');
    KeybClassRb.Caption := ReadString(Lang, 'TestClassCaption', 'Test class :');
    KeybFormRb.Caption := ReadString(Lang, 'TestFormCaption', 'Test form :');
    KeybRefreshBtn.Caption := ReadString(Lang, 'RefreshWindowListBtnCaption', 'Refresh window lists');
    PageControl.Pages[1].Caption := ReadString(Lang, 'ExecProgTitle', 'Execute program');
    PathLbl.Caption := ReadString(Lang, 'PathCaption', 'Path :');
    FirstTryCb.Caption := ReadString(Lang, 'FirstTryToCaption', 'First, try to...');
    CloseRb.Caption := ReadString(Lang, 'CloseCaption', 'Close');
    ActivateRb.Caption := ReadString(Lang, 'ActivateCaption', 'Activate');
    ExecClassRb.Caption := ReadString(Lang, 'TestClassCaption', 'Test class :');
    ExecFormRb.Caption := ReadString(Lang, 'TestFormCaption', 'Test form :');
    ExecRefreshBtn.Caption := ReadString(Lang, 'RefreshWindowListBtnCaption', 'Refresh window lists');
    PageControl.Pages[2].Caption := ReadString(Lang, 'VolumeControlTitle', 'Volume control');
    MixerLbl.Caption := ReadString(Lang, 'MixerDeviceCaption', 'Mixer device :');
    DestLbl.Caption := ReadString(Lang, 'MixerLineCaption', 'Mixer line :');
    MuteRb.Caption := ReadString(Lang, 'ToggleMuteCaption', 'Toggle mute');
    UpRb.Caption := ReadString(Lang, 'UpCaption', 'Up');
    DownRb.Caption := ReadString(Lang, 'DownCaption', 'Down');
    PageControl.Pages[3].Caption := ReadString(Lang, 'ChangeVarTitle', 'Change variable');
    VarNameLbl.Caption := ReadString(Lang, 'VarNameCaption', 'Variable name :');
    DefineVarBtn.Caption := ReadString(Lang, 'DefineVarBtnCaption', 'Define variables');
    VarLoopUpRb.Caption := ReadString(Lang, 'LoopValueUpCaption', 'Loop value up');
    VarLoopDnRb.Caption := ReadString(Lang, 'LoopValueDnCaption', 'Loop value down');
    SetValueRb.Caption := ReadString(Lang, 'SetValueCaption', 'Set value :');
    PageControl.Pages[4].Caption := ReadString(Lang, 'MiscTitle', 'Miscellaneous');
    ContactLbl.Caption := ReadString(Lang, 'ContactCaption', 'Your program is not in this list. Contact the author :');
    OkBtn.Caption := ReadString(Lang, 'OkBtnCaption', 'Ok');
    CancelBtn.Caption := ReadString(Lang, 'CancelBtnCaption', 'Cancel');
    for I := 0 to NBMORETVOPT - 1 do
      MORETVOPT[I] := ReadString(Lang, 'MoreTv' + IntToStr(I), 'MoreTv' + IntToStr(I));
    for I := 0 to NBKTVOPT - 1 do
      KTVOPT[I] := ReadString(Lang, 'KTV' + IntToStr(I), 'KTV' + IntToStr(I));
    for I := 0 to NBWINAMPOPT - 1 do
      WINAMPOPT[I] := ReadString(Lang, 'Winamp' + IntToStr(I), 'Winamp' + IntToStr(I));
    for I := 0 to NBWMPOPT - 1 do
      WMPOPT[I] := ReadString(Lang, 'WMP' + IntToStr(I), 'WMP' + IntToStr(I));
    for I := 0 to NBBSPLAYOPT - 1 do
      BSPLAYOPT[I] := ReadString(Lang, 'BsPlayer' + IntToStr(I), 'BsPlayer' + IntToStr(I));
    for I := 0 to NBPDVDOPT - 1 do
      PDVDOPT[I] := ReadString(Lang, 'PowerDVD' + IntToStr(I), 'PowerDVD' + IntToStr(I));
    for I := 0 to NBWINSTBOPT - 1 do
      WINSTBOPT[I] := ReadString(Lang, 'WinSTB' + IntToStr(I), 'WinSTB' + IntToStr(I));
    {for I := 0 to NBANOTHERPROGOPT - 1 do
      ANOTHERPROGOPT[I] := ReadString(Lang, 'AnotherProg' + IntToStr(I), 'AnotherProg' + IntToStr(I));}
  finally
    Free;
  end;
end;

//------------------------------------------------------------------------------

procedure TActionForm.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  ClientHeight := 280;
  ClientWidth := 345;
  Label1.Cursor := crHand;
  MiscSb.VertScrollBar.Position := 0;
  PageControl.ActivePageIndex := 4;
  KeyCombo.Clear;
  for I := 0 to NBKEYBKEYS - 1 do
    KeyCombo.Items.Add(KEYBKEYS[I].Name);
  RefreshBtnClick(nil);
  if AMixer.MixerCount > 0 then
    for I := 0 to AMixer.Destinations.Count - 1 do
      DeviceCombo.Items.Add(AMixer.Destinations[I].Data.szName);
  if DeviceCombo.Items.Count > 0 then
  begin
    DeviceCombo.ItemIndex := 0;
    DeviceComboChange(nil);
  end
  else VolumeTs.Enabled := False;
  RefreshVariables;
  ApplyLanguage(CurrentLanguageStr);
  OSDCombo.Clear;
  for I := 0 to NBOSDOPT - 1 do
    OSDCombo.Items.Add(OSDOPT[I]);
  OSDCombo.ItemIndex := 0;
  MoreTVCombo.Clear;
  for I := 0 to NBMORETVOPT - 1 do
    MoreTVCombo.Items.Add(MORETVOPT[I]);
  MoreTVCombo.ItemIndex := 0;
  KTVCombo.Clear;
  for I := 0 to NBKTVOPT - 1 do
    KTVCombo.Items.Add(KTVOPT[I]);
  KTVCombo.ItemIndex := 0;
  WinampCombo.Clear;
  for I := 0 to NBWINAMPOPT - 1 do
    WinampCombo.Items.Add(WINAMPOPT[I]);
  WinampCombo.ItemIndex := 0;
  for I := 0 to NBWMPOPT - 1 do
    MediaPlayerCombo.Items.Add(WMPOPT[I]);
  MediaPlayerCombo.ItemIndex := 0;
  for I := 0 to NBBSPLAYOPT - 1 do
    BSPlayerCombo.Items.Add(BSPLAYOPT[I]);
  BSPlayerCombo.ItemIndex := 0;
  for I := 0 to NBPDVDOPT - 1 do
    PowerDVDCombo.Items.Add(PDVDOPT[I]);
  PowerDVDCombo.ItemIndex := 0;
  for I := 0 to NBWINSTBOPT - 1 do
    WinSTBCombo.Items.Add(WINSTBOPT[I]);
  WinSTBCombo.ItemIndex := 0;
{  for I := 0 to NBANOTHERPROGOPT - 1 do
    AnotherProgCombo.Items.Add(ANOTHERPROGOPT[I]);
  AnotherProgCombo.ItemIndex := 0;}
end;

//------------------------------------------------------------------------------

procedure TActionForm.FirstTryCbClick(Sender: TObject);
begin
  CloseRb.Enabled := FirstTryCb.Checked;
  ActivateRb.Enabled := FirstTryCb.Checked;
  ExecClassRb.Enabled := FirstTryCb.Checked;
  ExecFormRb.Enabled := FirstTryCb.Checked;
  ExecClassCombo.Enabled := FirstTryCb.Checked;
  ExecFormCombo.Enabled := FirstTryCb.Checked;
  ExecRefreshBtn.Enabled := FirstTryCb.Checked;
end;

//------------------------------------------------------------------------------

procedure TActionForm.RefreshBtnClick(Sender: TObject);
var
  AHandle: HWnd;
  PCharResult: PChar;
  TextLength: Integer;
begin
  KeybClassCombo.Items.Clear;
  KeybFormCombo.Items.Clear;
  ExecClassCombo.Items.Clear;
  ExecFormCombo.Items.Clear;
  AHandle := GetWindow(Handle, GW_HWNDFIRST);
  while Ahandle <> NULL_HANDLE do
  begin
    TextLength := GetWindowTextLength(AHandle) + 1;
    if TextLength > 1 then
    begin
      GetMem(PCharResult, 255);
      GetClassName(AHandle, PCharResult, 255);
      KeybClassCombo.Items.Add(string(PCharResult));
      ExecClassCombo.Items.Add(string(PCharResult));
      Freemem(PCharResult);
      GetMem(PCharResult, TextLength);
      GetWindowText(AHandle, PCharResult, TextLength);
      KeybFormCombo.Items.Add(string(PCharResult));
      ExecFormCombo.Items.Add(string(PCharResult));
      Freemem(PCharResult);
    end;
    AHandle := GetNextWindow(AHandle, GW_HWNDNEXT);
  end;
end;

//------------------------------------------------------------------------------

procedure TActionForm.BrowseBtnClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    PathEdt.Text := OpenDialog.FileName;
end;

//------------------------------------------------------------------------------

procedure TActionForm.ComboChange(Sender: TObject);
begin
  KeybClassRb.Checked := Sender = KeybClassCombo;
  KeybFormRb.Checked := Sender = KeybFormCombo;
  ExecClassRb.Checked := Sender = ExecClassCombo;
  ExecFormRb.Checked := Sender = ExecFormCombo;
end;

//------------------------------------------------------------------------------

procedure TActionForm.DeviceComboChange(Sender: TObject);
var
  I: Integer;
begin
  LineCombo.Items.Clear;
  LineCombo.Items.Add(AMixer.Destinations[DeviceCombo.ItemIndex].Data.szName);
  for I := 0 to AMixer.Destinations[DeviceCombo.ItemIndex].Connections.Count - 1 do
    LineCombo.Items.Add(AMixer.Destinations[DeviceCombo.ItemIndex].Connections[I].Data.szName);
  if LineCombo.Items.Count > 0 then
    LineCombo.ItemIndex := 0
  else
    LineCombo.Enabled := False;
end;

//------------------------------------------------------------------------------

procedure TActionForm.DefineVarBtnClick(Sender: TObject);
begin
  with TVarDefForm.Create(Self) do
  try
    ShowModal;
    RefreshVariables;
  finally
    Free;
  end;
end;

//------------------------------------------------------------------------------

procedure TActionForm.VarNameComboChange(Sender: TObject);
begin
  VarValueCombo.Clear;
  VarValueCombo.Items.AddStrings(Variables[VarNameCombo.ItemIndex].Values);
  if VarValueCombo.Items.Count > 0 then
    VarValueCombo.itemIndex := 0;
end;

//------------------------------------------------------------------------------

procedure TActionForm.VarValueComboChange(Sender: TObject);
begin
  SetValueRb.Checked := True;
end;

//------------------------------------------------------------------------------

procedure TActionForm.MiscComboChange(Sender: TObject);
begin
  if Sender = OSDCombo then
    OSDRb.Checked := True
  else if Sender = MoreTVCombo then
    MoreTVRb.Checked := True
  else if Sender = KTVCombo then
    KTVRb.Checked := True
  else if Sender = WinampCombo then
    WinampRb.Checked := True
  else if Sender = MediaPlayerCombo then
    MediaPlayerRb.Checked := True
  else if Sender = BsPlayerCombo then
    BSPlayerRb.Checked := True
  else if Sender = PowerDVDCombo then
    PowerDVDRb.Checked := True
  else if Sender = WinSTBCombo then
    WinSTBRb.Checked := True
  {else if Sender = AnotherProgCombo then
    AnotherProgRb.Checked := True};
end;

//------------------------------------------------------------------------------

procedure TActionForm.Label1Click(Sender: TObject);
begin
  ShellExecute(0, 'open', 'mailto:maxxdelphisite@free.fr', nil, nil, SW_SHOWNORMAL);
end;

end.

