unit UConfigCOMPort;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, ExtCtrls, UgradPnl;

type
  TConfigCOMPortForm = class(TForm)
    ComPortNameCombo: TComboBox;
    ComPortNameLbl: TLabel;
    OkBtn: TButton;
    CancelBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    FGradPnl: TgradientPanel;
  public
    procedure ApplyLanguage(Lang: string);
  end;

var
  ConfigCOMPortForm: TConfigCOMPortForm;

implementation

uses UMain, UComPort;

{$R *.dfm}

//------------------------------------------------------------------------------

procedure TConfigCOMPortForm.ApplyLanguage(Lang: string);
begin
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.lang')) do
  try
    FGradPnl.Caption := ReadString(Lang, 'COMPortTitle', 'Configuration - COM Port');
    ComPortNameLbl.Caption := ReadString(Lang, 'PortCaption', 'Port :');
    OkBtn.Caption := ReadString(Lang, 'OkBtnCaption', 'Ok');
    CancelBtn.Caption := ReadString(Lang, 'CancelBtnCaption', 'Cancel');
  finally
    Free;
  end;
end;

//------------------------------------------------------------------------------

procedure TConfigCOMPortForm.FormCreate(Sender: TObject);
begin
  ClientHeight := 140;
  ClientWidth := 330;
  FGradPnl := TgradientPanel.Create(Self);
  with FGradPnl do
  begin
    Parent := Self;
    Align := alTop;
    Caption := 'Configuration - COM port';
    Font.Name := 'Arial';
    Font.Size := 14;
    Font.Style := [fsBold];
    Font.Color := clWhite;
    FEndColor := clBtnFace;
    ;
    FBeginColor := clBlack;
  end;
  EnumComPorts(ComPortNameCombo.Items);
  if ComPortNameCombo.Items.IndexOf(ComPort.Port) > -1 then
    ComPortNameCombo.ItemIndex := ComPortNameCombo.Items.IndexOf(ComPort.Port)
  else if ComPortNameCombo.Items.Count > 0 then
    ComPortNameCombo.ItemIndex := 0;
  ApplyLanguage(CurrentLanguageStr);
end;

//------------------------------------------------------------------------------

procedure TConfigCOMPortForm.OkBtnClick(Sender: TObject);
begin
  if ComPortNameCombo.Items[ComPortNameCombo.ItemIndex] <> ComPort.Port then
  begin
    ComPort.Close;
    ComPort.Port := ComPortNameCombo.Items[ComPortNameCombo.ItemIndex];
    ComPort.Open;
    with TIniFile.Create(IniFileStr) do
    try
      WriteString('ComPort', 'Name', ComPort.Port);
    finally
      Free;
    end;
  end;
  Close;
end;

//------------------------------------------------------------------------------

procedure TConfigCOMPortForm.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

//------------------------------------------------------------------------------

end.

