unit UConfigLang;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, UgradPnl;

type
  TConfigLangForm = class(TForm)
    LanguageNameLbl: TLabel;
    LanguageNameCombo: TComboBox;
    OkBtn: TButton;
    CancelBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure LanguageNameComboChange(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    FGradPnl: TgradientPanel;
  end;

var
  ConfigLangForm: TConfigLangForm;

implementation

uses UMain, UConfigKeys, UConfigCOMPort, UConfigOSD, UCaptureKey, UVarDef,
  UFunction, UAction;

{$R *.dfm}

procedure TConfigLangForm.FormCreate(Sender: TObject);
begin
  ClientHeight := 140;
  ClientWidth := 330;
  FGradPnl := TgradientPanel.Create(Self);
  with FGradPnl do
  begin
    Parent := Self;
    Align := alTop;
    Caption := 'Configuration - COM Port';
    Font.Name := 'Arial';
    Font.Size := 14;
    Font.Style := [fsBold];
    Font.Color := clWhite;
    FEndColor := clBtnFace;;
    FBeginColor := clBlack;
  end;
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.lang')) do
  try
    ReadSections(LanguageNameCombo.Items);
  finally
    Free;
  end;
  LanguageNameCombo.ItemIndex := LanguageNameCombo.Items.IndexOf(CurrentLanguageStr);
  LanguageNameComboChange(nil);
end;

procedure TConfigLangForm.OkBtnClick(Sender: TObject);
begin
  CurrentLanguageStr := LanguageNameCombo.Items[LanguageNameCombo.ItemIndex];
  if ConfigKeysForm <> nil then
    ConfigKeysForm.ApplyLanguage(CurrentLanguageStr);
  if ConfigCOMPortForm <> nil then
    ConfigCOMPortForm.ApplyLanguage(CurrentLanguageStr);
  if ConfigOSDForm <> nil then
    ConfigOSDForm.ApplyLanguage(CurrentLanguageStr);
  MainForm.ApplyLanguage(CurrentLanguageStr);
  if CaptureKeyForm <> nil then
    CaptureKeyForm.ApplyLanguage(CurrentLanguageStr);
  if VarDefForm <> nil then
    VarDefForm.ApplyLanguage(CurrentLanguageStr);
  if FunctionForm <> nil then
    FunctionForm.ApplyLanguage(CurrentLanguageStr);
  if ActionForm <> nil then
    ActionForm.ApplyLanguage(CurrentLanguageStr);
  with TIniFile.Create(IniFileStr) do
  try
    WriteString('Main', 'Language', CurrentLanguageStr);
  finally
    Free;
  end;
  Close;
end;

procedure TConfigLangForm.LanguageNameComboChange(Sender: TObject);
begin
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.lang')) do
  try
    FGradPnl.Caption := ReadString(LanguageNameCombo.Items[LanguageNameCombo.ItemIndex], 'LanguageTitle', 'Configuration - Language');
    LanguageNameLbl.Caption := ReadString(LanguageNameCombo.Items[LanguageNameCombo.ItemIndex], 'LanguageCaption', 'Language :');
    OkBtn.Caption := ReadString(LanguageNameCombo.Items[LanguageNameCombo.ItemIndex], 'OkBtnCaption', 'Ok');
    CancelBtn.Caption := ReadString(LanguageNameCombo.Items[LanguageNameCombo.ItemIndex], 'CancelBtnCaption', 'Cancel');
  finally
    Free;
  end;
end;

procedure TConfigLangForm.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

end.
