unit UKeybEmul;

interface

uses
  Windows, SysUtils, Messages, UMain;

type
  TKeybKey = record
    Name: string;
    Ch: Char;
  end;

const
  NBKEYBKEYS = 118;
  KEYBKEYS: array[0..NBKEYBKEYS - 1] of TKeybKey = (
    (Name: 'Left mouse button [VK_LBUTTON]'; Ch: #1),
    (Name: 'Right mouse button [VK_RBUTTON]'; Ch: #2),
    (Name: 'Control-break processing [VK_CANCEL]'; Ch: #3),
    (Name: 'Middle mouse button (three-button mouse) [VK_MBUTTON]'; Ch: #4),
    (Name: 'BACKSPACE key [VK_BACK]'; Ch: #8),
    (Name: 'TAB key [VK_TAB]'; Ch: #9),
    (Name: 'CLEAR key [VK_CLEAR]'; Ch: #12),
    (Name: 'ENTER key [VK_RETURN]'; Ch: #13),
    (Name: 'SHIFT key [VK_SHIFT]'; Ch: #16),
    (Name: 'CTRL key [VK_CONTROL]'; Ch: #17),
    (Name: 'ALT key [VK_MENU]'; Ch: #18),
    (Name: 'PAUSE key [VK_PAUSE]'; Ch: #19),
    (Name: 'CAPS LOCK key [VK_CAPITAL]'; Ch: #20),
    (Name: 'ESC key [VK_ESCAPE]'; Ch: #27),
    (Name: 'SPACEBAR [VK_SPACE]'; Ch: #32),
    (Name: 'PAGE UP key [VK_PRIOR]'; Ch: #33),
    (Name: 'PAGE DOWN key [VK_NEXT]'; Ch: #34),
    (Name: 'END key [VK_END]'; Ch: #35),
    (Name: 'HOME key [VK_HOME]'; Ch: #36),
    (Name: 'LEFT ARROW key [VK_LEFT]'; Ch: #37),
    (Name: 'UP ARROW key [VK_UP]'; Ch: #38),
    (Name: 'RIGHT ARROW key [VK_RIGHT]'; Ch: #39),
    (Name: 'DOWN ARROW key [VK_DOWN]'; Ch: #40),
    (Name: 'SELECT key [VK_SELECT]'; Ch: #41),
    (Name: 'EXECUTE key [VK_EXECUTE]'; Ch: #43),
    (Name: 'PRINT SCREEN key for Windows 3.0 and later [VK_SNAPSHOT]'; Ch: #44),
    (Name: 'INS key [VK_INSERT]'; Ch: #45),
    (Name: 'DEL key [VK_DELETE]'; Ch: #46),
    (Name: 'HELP key [VK_HELP]'; Ch: #47),
    (Name: '0 key [VK_0]'; Ch: #48),
    (Name: '1 key [VK_1]'; Ch: #49),
    (Name: '2 key [VK_2]'; Ch: #50),
    (Name: '3 key [VK_3]'; Ch: #51),
    (Name: '4 key [VK_4]'; Ch: #52),
    (Name: '5 key [VK_5]'; Ch: #53),
    (Name: '6 key [VK_6]'; Ch: #54),
    (Name: '7 key [VK_7]'; Ch: #55),
    (Name: '8 key [VK_8]'; Ch: #56),
    (Name: '9 key [VK_9]'; Ch: #57),
    (Name: 'A key [VK_A]'; Ch: #65),
    (Name: 'B key [VK_B]'; Ch: #66),
    (Name: 'C key [VK_C]'; Ch: #67),
    (Name: 'D key [VK_D]'; Ch: #68),
    (Name: 'E key [VK_E]'; Ch: #69),
    (Name: 'F key [VK_F]'; Ch: #70),
    (Name: 'G key [VK_G]'; Ch: #71),
    (Name: 'H key [VK_H]'; Ch: #72),
    (Name: 'I key [VK_I]'; Ch: #73),
    (Name: 'J key [VK_J]'; Ch: #74),
    (Name: 'K key [VK_K]'; Ch: #75),
    (Name: 'L key [VK_L]'; Ch: #76),
    (Name: 'M key [VK_M]'; Ch: #77),
    (Name: 'N key [VK_N]'; Ch: #78),
    (Name: 'O key [VK_O]'; Ch: #79),
    (Name: 'P key [VK_P]'; Ch: #80),
    (Name: 'Q key [VK_Q]'; Ch: #81),
    (Name: 'R key [VK_R]'; Ch: #82),
    (Name: 'S key [VK_S]'; Ch: #83),
    (Name: 'T key [VK_T]'; Ch: #84),
    (Name: 'U key [VK_U]'; Ch: #85),
    (Name: 'V key [VK_V]'; Ch: #86),
    (Name: 'W key [VK_W]'; Ch: #87),
    (Name: 'X key [VK_X]'; Ch: #88),
    (Name: 'Y key [VK_Y]'; Ch: #89),
    (Name: 'Z key [VK_Z]'; Ch: #90),
    (Name: 'Left Windows key (Microsoft Natural Keyboard) [VK_LWIN]'; Ch: #91),
    (Name: 'Right Windows key (Microsoft Natural Keyboard) [VK_RWIN]'; Ch: #92),
    (Name: 'Applications key (Microsoft Natural Keyboard) [VK_APPS]'; Ch: #93),
    (Name: 'Numeric keypad 0 key [VK_NUMPAD0]'; Ch: #96),
    (Name: 'Numeric keypad 1 key [VK_NUMPAD1]'; Ch: #97),
    (Name: 'Numeric keypad 2 key [VK_NUMPAD2]'; Ch: #98),
    (Name: 'Numeric keypad 3 key [VK_NUMPAD3]'; Ch: #99),
    (Name: 'Numeric keypad 4 key [VK_NUMPAD4]'; Ch: #100),
    (Name: 'Numeric keypad 5 key [VK_NUMPAD5]'; Ch: #101),
    (Name: 'Numeric keypad 6 key [VK_NUMPAD6]'; Ch: #102),
    (Name: 'Numeric keypad 7 key [VK_NUMPAD7]'; Ch: #103),
    (Name: 'Numeric keypad 8 key [VK_NUMPAD8]'; Ch: #104),
    (Name: 'Numeric keypad 9 key [VK_NUMPAD9]'; Ch: #105),
    (Name: 'Multiply key [VK_MULTIPLY]'; Ch: #106),
    (Name: 'Add key [VK_ADD]'; Ch: #107),
    (Name: 'Separator key [VK_SEPARATOR]'; Ch: #108),
    (Name: 'Subtract key [VK_SUBTRACT]'; Ch: #109),
    (Name: 'Decimal key [VK_DECIMAL]'; Ch: #110),
    (Name: 'Divide key [VK_DIVIDE]'; Ch: #111),
    (Name: 'F1 key [VK_F1]'; Ch: #112),
    (Name: 'F2 key [VK_F2]'; Ch: #113),
    (Name: 'F3 key [VK_F3]'; Ch: #114),
    (Name: 'F4 key [VK_F4]'; Ch: #115),
    (Name: 'F5 key [VK_F5]'; Ch: #116),
    (Name: 'F6 key [VK_F6]'; Ch: #117),
    (Name: 'F7 key [VK_F7]'; Ch: #118),
    (Name: 'F8 key [VK_F8]'; Ch: #119),
    (Name: 'F9 key [VK_F9]'; Ch: #120),
    (Name: 'F10 key [VK_F10]'; Ch: #121),
    (Name: 'F11 key [VK_F11]'; Ch: #122),
    (Name: 'F12 key [VK_F12]'; Ch: #123),
    (Name: 'F13 key [VK_F13]'; Ch: #124),
    (Name: 'F14 key [VK_F14]'; Ch: #125),
    (Name: 'F15 key [VK_F15]'; Ch: #126),
    (Name: 'F16 key [VK_F16]'; Ch: #127),
    (Name: 'F17 key [VK_F17]'; Ch: #128),
    (Name: 'F18 key [VK_F18]'; Ch: #129),
    (Name: 'F19 key [VK_F19]'; Ch: #130),
    (Name: 'F20 key [VK_F20]'; Ch: #131),
    (Name: 'F21 key [VK_F21]'; Ch: #132),
    (Name: 'F22 key [VK_F22]'; Ch: #133),
    (Name: 'F23 key [VK_F23]'; Ch: #134),
    (Name: 'F24 key [VK_F24]'; Ch: #135),
    (Name: 'NUM LOCK key [VK_NUMLOCK]'; Ch: #144),
    (Name: 'SCROLL LOCK key [VK_SCROLL]'; Ch: #145),
    (Name: 'Attn key [VK_ATTN]'; Ch: #246),
    (Name: 'CrSel key [VK_CRSEL]'; Ch: #247),
    (Name: 'ExSel key [VK_EXSEL]'; Ch: #248),
    (Name: 'Erase EOF key [VK_EREOF]'; Ch: #249),
    (Name: 'Play key [VK_PLAY]'; Ch: #250),
    (Name: 'Zoom key [VK_ZOOM]'; Ch: #251),
    (Name: 'PA1 key [VK_PA1]'; Ch: #253),
    (Name: 'Clear key [VK_OEM_CLEAR]'; Ch: #254));

procedure KeyboardEmulation(Target: HWnd; Ch: Integer; Alt: Boolean = False; Ctrl: Boolean = False; Shift: Boolean = False; Win: Boolean = False);

implementation

procedure KeyboardEmulation(Target: HWnd; Ch: Integer; Alt: Boolean = False; Ctrl: Boolean = False; Shift: Boolean = False; Win: Boolean = False);
var
  ScanCode: Word;
begin
  if Alt then Keybd_Event(VK_MENU, MapVirtualKey(VK_MENU, 0), 0, 0);
  if Ctrl then Keybd_Event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
  if Shift then Keybd_Event(VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), 0, 0);
  if Win then Keybd_Event(VK_LWIN, MapVirtualKey(VK_LWIN, 0), 0, 0);

  if Target = NULL_HANDLE then
  begin
    ScanCode := MapVirtualKey(Ch, 0);
    Keybd_Event(Ch, ScanCode, 0, 0);
    Keybd_Event(Ch, ScanCode, KEYEVENTF_KEYUP, 0);
  end
  else begin
    PostMessage(Target, WM_KEYDOWN, Ch, 0);
    PostMessage(Target, WM_KEYUP, Ch, 0);
  end;

  if Alt then Keybd_Event(VK_MENU, MapVirtualKey(VK_MENU, 0), KEYEVENTF_KEYUP, 0);
  if Ctrl then Keybd_Event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
  if Shift then Keybd_Event(VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), KEYEVENTF_KEYUP, 0);
  if Win then Keybd_Event(VK_LWIN, MapVirtualKey(VK_LWIN, 0), KEYEVENTF_KEYUP, 0);
end;


end.

