unit UWizard;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, jpeg, StdCtrls, CheckLst, ComCtrls, Buttons, ExtCtrls, Math,
  IniFiles, UComPort;

type
  TWizardForm = class(TForm)
    TopPnl: TPanel;
    InfoTitleLbl: TLabel;
    InfoLbl: TLabel;
    Image1: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    BottomPnl: TPanel;
    CancelBtn: TBitBtn;
    NextBtn: TBitBtn;
    PrevBtn: TBitBtn;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    SoftsLb: TCheckListBox;
    TabSheet3: TTabSheet;
    DefaultImg: TImage;
    IntroImg: TImage;
    IntroLbl: TLabel;
    ContactLbl: TLabel;
    Label1: TLabel;
    MoveUpBtn: TBitBtn;
    MoveDownBtn: TBitBtn;
    SoftImg: TImage;
    DownCb: TCheckBox;
    UpCb: TCheckBox;
    PCb: TCheckBox;
    TabCb: TCheckBox;
    MenuCb: TCheckBox;
    LeftCb: TCheckBox;
    RightCb: TCheckBox;
    PageDnCb: TCheckBox;
    PageUpCb: TCheckBox;
    OffCb: TCheckBox;
    VolMinusCb: TCheckBox;
    VolPlusCb: TCheckBox;
    RadioEdt: TEdit;
    EPGBtn: TButton;
    RadioBtn: TButton;
    EPGEdt: TEdit;
    TeletextEdt: TEdit;
    TVEdt: TEdit;
    TeletextBtn: TButton;
    TVBtn: TButton;
    SupportedSoftLbl: TLabel;
    SoftLbl1: TLabel;
    SoftLbl2: TLabel;
    SoftLbl3: TLabel;
    SoftLbl4: TLabel;
    SoftLbl5: TLabel;
    SoftLbl6: TLabel;
    SoftLbl7: TLabel;
    AnotherProgLbl: TLabel;
    EnterCb: TCheckBox;
    MuteAllCb: TCheckBox;
    OpenDialog: TOpenDialog;
    LanguageCombo: TComboBox;
    LanguageLbl: TLabel;
    COMPortLbl: TLabel;
    COMCombo: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure PrevBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure BrowseBtnClick(Sender: TObject);
    procedure SoftsLbClick(Sender: TObject);
    procedure SoftsLbKeyPress(Sender: TObject; var Key: Char);
    procedure MoveBtnClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure LanguageComboChange(Sender: TObject);
  private
    FNextStr: string;
    FFinishStr: string;
    FPCTVJpg: TJPEGImage;
    Titles: array[0..2] of string;
    TitleInfos: array[0..2] of string;
  public
    procedure ApplyLanguage(Lang: string);
  end;

var
  WizardForm: TWizardForm;

const
  MoreTVStr = 'MoreTV';
  KTVStr = 'K!TV XP';
  Winamp2Str = 'Winamp 2';
  Winamp3Str = 'Winamp 3';
  Winamp5Str = 'Winamp 5';
  WMPStr = 'Windows media player';
  BSPlayerStr = 'BS Player';
  PowerDVDStr = 'PowerDVD';
  WinSTBStr = 'WinSTB';
  //AnotherProgStr = 'Another prog'

implementation

uses UMain, UAction;

{$R *.dfm}

//------------------------------------------------------------------------------

procedure TWizardForm.ApplyLanguage(Lang: string);
begin
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.lang')) do
  try
    COMPortLbl.Caption := ReadString(Lang, 'PortCaption', 'Port :');
    LanguageLbl.Caption := ReadString(Lang, 'LanguageCaption', 'Language :');
    Self.Caption := ReadString(Lang, 'WizardTitle', 'PC Remote wizard - First execution');
    PrevBtn.Caption := ReadString(Lang, 'BackBtnCaption', '< Back');
    FNextStr := ReadString(Lang, 'NextBtnCaption', 'Next >');
    NextBtn.Caption := FNextStr;
    FFinishStr := ReadString(Lang, 'FinnishBtnCaption', 'Finish');
    CancelBtn.Caption := ReadString(Lang, 'CancelBtnCaption', 'Finish');
    Titles[0] := ReadString(Lang, 'WinzardTitles0', 'PC Remote');
    TitleInfos[0] := ReadString(Lang, 'WizardTitleInfos0', 'Key configuration wizard.');
    Titles[1] := ReadString(Lang, 'WinzardTitles1', 'Known software configuration');
    TitleInfos[1] := ReadString(Lang, 'WizardTitleInfos1a', 'Choose the programs you want to command with the Pinnacle PCTV Remote. Place them in order of importance.') + #13#10 + ReadString(Lang, 'WizardTitleInfos1b', 'For exemple, if both Winamp and BS Player are running, which one should be commanded ?');
    Titles[2] := ReadString(Lang, 'WinzardTitles2', 'Default configuration');
    TitleInfos[2] := ReadString(Lang, 'WizardTitleInfos2', 'Select the keys that should have a default action.');
    IntroLbl.Caption := ReadString(Lang, 'WizardIntro', 'If you have the Pinnacle PCTV Remote (this picture), then this wizard will configure some keys to command the programs you are using.');
    SupportedSoftLbl.Caption := ReadString(Lang, 'WizardIntro2', 'Supported software are :');
    ContactLbl.Caption := ReadString(Lang, 'WizardContact', 'The program you are using is not in this list ? Contact the author :');
  finally
    Free;
  end;
end;

//------------------------------------------------------------------------------

procedure TWizardForm.FormCreate(Sender: TObject);
var
  OffSet: Integer;

  procedure DrawRect(Canvas: TCanvas; X1, Y1, X2, Y2, X3: Integer; Y3: Integer = -1);
  begin
    Canvas.FrameRect(Rect(X1, Y1, X2, Y2));
    Canvas.FrameRect(Rect(X1 + 1, Y1 + 1, X2 - 1, Y2 - 1));
    if Y3 = -1 then
    begin
      Canvas.MoveTo(IfThen(X3 < X1, X1, X2), (Y1 + Y2) div 2);
      Canvas.LineTo(X3, (Y1 + Y2) div 2);
      Canvas.MoveTo(IfThen(X3 < X1, X1, X2), (Y1 + Y2) div 2 + 1);
      Canvas.LineTo(X3, (Y1 + Y2) div 2 + 1);
    end
    else begin
      Canvas.MoveTo((X1 + X2) div 2, IfThen(Y3 < Y1, Y1, Y2));
      Canvas.LineTo((X1 + X2) div 2, Y3);
      Canvas.LineTo(X3, Y3);
      Canvas.MoveTo((X1 + X2) div 2 + 1, IfThen(Y3 < Y1, Y1, Y2));
      Canvas.LineTo((X1 + X2) div 2 + 1, Y3 + 1);
      Canvas.LineTo(X3, Y3 + 1);
    end;
  end;

begin
  FPCTVJpg := TJPEGImage.Create;
  FPCTVJpg.LoadFromFile(IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName)) + '1_pctv_41keys\pctv.jpg');
  Label1.Cursor := crHand;
  Label3.Cursor := crHand;
  ApplyLanguage(CurrentLanguageStr);
  EnumComPorts(COMCombo.Items);
  if COMCombo.Items.Count > 0 then
    COMCombo.ItemIndex := 0;
  with TIniFile.Create(ChangeFileExt(Application.ExeName, '.lang')) do
  try
    ReadSections(LanguageCombo.Items);
    if LanguageCombo.Items.Count > 0 then
      LanguageCombo.ItemIndex := 0;
  finally
    Free;
  end;
  InfoTitleLbl.Caption := Titles[0];
  InfoLbl.Caption := TitleInfos[0];
  SoftsLb.Items.Add(MoreTVStr);
  SoftsLb.Items.Add(KTVStr);
  SoftsLb.Items.Add(Winamp2Str);
  SoftsLb.Items.Add(Winamp3Str);
  SoftsLb.Items.Add(Winamp5Str);
  SoftsLb.Items.Add(WMPStr);
  SoftsLb.Items.Add(BSPlayerStr);
  SoftsLb.Items.Add(PowerDVDStr);
  SoftsLb.Items.Add(WinSTBStr);
  //SoftsLb.Items.Add(AnotherProgStr);
  PageControl.ActivePageIndex := 0;
  with IntroImg.Canvas do
  begin
    Brush.Color := clBtnFace;
    FillRect(ClipRect);
    Draw(0, 0, FPCTVJpg);
  end;
  with SoftImg.Canvas do
  begin
    OffSet := (SoftImg.Width - FPCTVJpg.Width) div 2;
    Brush.Color := clBtnFace;
    FillRect(ClipRect);
    Draw(OffSet, 0, FPCTVJpg);
    Brush.Style := bsClear;
    Brush.Color := clHotLight;
    Pen.Color := clHotLight;
  end;
  with DefaultImg.Canvas do
  begin
    OffSet := (DefaultImg.Width - FPCTVJpg.Width) div 2;
    Brush.Color := clBtnFace;
    FillRect(ClipRect);
    Draw(OffSet, 0, FPCTVJpg);
    Brush.Style := bsClear;
    Brush.Color := clHotLight;
    Pen.Color := clHotLight;
  end;
  DrawRect(DefaultImg.Canvas, OffSet + 109, 1, OffSet + 139, 31, OffSet + 160);
  DrawRect(DefaultImg.Canvas, OffSet + 107, 38, OffSet + 141, 63, OffSet + 160);
  DrawRect(DefaultImg.Canvas, OffSet + 15, 121, OffSet + 41, 149, OffSet - 5);
  DrawRect(DefaultImg.Canvas, OffSet + 46, 121, OffSet + 73, 149, OffSet - 5, 94);
  DrawRect(DefaultImg.Canvas, OffSet + 108, 122, OffSet + 134, 149, OffSet + 160);
  DrawRect(DefaultImg.Canvas, OffSet + 15, 150, OffSet + 43, 178, OffSet - 5);
  DrawRect(DefaultImg.Canvas, OffSet + 108, 150, OffSet + 135, 178, OffSet + 160);
  DrawRect(DefaultImg.Canvas, OffSet + 55, 155, OffSet + 96, 183, OffSet + 160, 94);
  DrawRect(DefaultImg.Canvas, OffSet + 27, 182, OffSet + 54, 224, OffSet - 5);
  DrawRect(DefaultImg.Canvas, OffSet + 63, 192, OffSet + 88, 215, OffSet + 160, 184);
  DrawRect(DefaultImg.Canvas, OffSet + 97, 187, OffSet + 124, 224, OffSet + 160);
  DrawRect(DefaultImg.Canvas, OffSet + 55, 224, OffSet + 96, 252, OffSet + 160, 284);
  DrawRect(DefaultImg.Canvas, OffSet + 17, 225, OffSet + 41, 252, OffSet - 5);
  DrawRect(DefaultImg.Canvas, OffSet + 110, 225, OffSet + 134, 252, OffSet + 160);
  DrawRect(DefaultImg.Canvas, OffSet + 17, 316, OffSet + 42, 344, 220, 366);
  DrawRect(DefaultImg.Canvas, OffSet + 47, 316, OffSet + 72, 344, 220, 390);
  DrawRect(DefaultImg.Canvas, OffSet + 78, 316, OffSet + 103, 344, 396, 390);
  DrawRect(DefaultImg.Canvas, OffSet + 110, 316, OffSet + 135, 344, 396, 366);
end;

//------------------------------------------------------------------------------

procedure TWizardForm.NextBtnClick(Sender: TObject);
begin
  PrevBtn.Enabled := True;
  with PageControl do
    if ActivePageIndex >= PageCount - 1 then
      ModalResult := mrOk
    else begin
      ActivePageIndex := ActivePageIndex + 1;
      if ActivePageIndex >= PageCount - 1 then NextBtn.Caption := FFinishStr
      else NextBtn.Caption := FNextStr;
      InfoTitleLbl.Caption := Titles[ActivePageIndex];
      InfoLbl.Caption := TitleInfos[ActivePageIndex];
    end;
end;

//------------------------------------------------------------------------------

procedure TWizardForm.PrevBtnClick(Sender: TObject);
begin
  with PageControl do
  begin
    if ActivePageIndex > 0 then
      ActivePageIndex := ActivePageIndex - 1;
    PrevBtn.Enabled := ActivePageIndex > 0;
    NextBtn.Caption := FNextStr;
    InfoTitleLbl.Caption := Titles[ActivePageIndex];
    InfoLbl.Caption := TitleInfos[ActivePageIndex];
  end;
end;

//------------------------------------------------------------------------------

procedure TWizardForm.CancelBtnClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

//------------------------------------------------------------------------------

procedure TWizardForm.BrowseBtnClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    if Sender = TVBtn then
      TVEdt.Text := OpenDialog.FileName
    else if Sender = TeletextBtn then
      TeletextEdt.Text := OpenDialog.FileName
    else if Sender = RadioBtn then
      RadioEdt.Text := OpenDialog.FileName
    else if Sender = EPGBtn then
      EPGEdt.Text := OpenDialog.FileName;
end;

//------------------------------------------------------------------------------

procedure TWizardForm.SoftsLbClick(Sender: TObject);
var
  OffSet: Integer;

  procedure DrawRect(Canvas: TCanvas; X1, Y1, X2, Y2: Integer; Text: string; X3: Integer; Y3: Integer = -1);
  begin
    Canvas.Brush.Color := clHotLight;
    Canvas.FrameRect(Rect(X1, Y1, X2, Y2));
    Canvas.FrameRect(Rect(X1 + 1, Y1 + 1, X2 - 1, Y2 - 1));
    Canvas.Brush.Color := clBtnFace;
    if Y3 = -1 then
    begin
      Canvas.MoveTo(IfThen(X3 < X1, X1, X2), (Y1 + Y2) div 2);
      Canvas.LineTo(X3, (Y1 + Y2) div 2);
      Canvas.MoveTo(IfThen(X3 < X1, X1, X2), (Y1 + Y2) div 2 + 1);
      Canvas.LineTo(X3, (Y1 + Y2) div 2 + 1);
      Canvas.TextOut(IfThen(X3 < X1, X3 - Canvas.TextWidth(Text), X3), (Y1 + Y2 - Canvas.TextHeight(Text)) div 2, Text);
    end
    else begin
      Canvas.MoveTo((X1 + X2) div 2, IfThen(Y3 < Y1, Y1, Y2));
      Canvas.LineTo((X1 + X2) div 2, Y3);
      Canvas.LineTo(X3, Y3);
      Canvas.MoveTo((X1 + X2) div 2 + 1, IfThen(Y3 < Y1, Y1, Y2));
      Canvas.LineTo((X1 + X2) div 2 + 1, Y3 + 1);
      Canvas.LineTo(X3, Y3 + 1);
      Canvas.TextOut(IfThen(X3 < X1, X3 - Canvas.TextWidth(Text), X3), Y3 - Canvas.TextHeight(Text) div 2, Text);
    end;
  end;

begin
  with SoftImg.Canvas do
  begin
    OffSet := (SoftImg.Width - FPCTVJpg.Width) div 2;
    Brush.Color := clBtnFace;
    FillRect(ClipRect);
    Draw(OffSet, 0, FPCTVJpg);
    Pen.Color := clHotLight;
  end;
  if SoftsLb.Items[SoftsLb.ItemIndex] = MoreTvStr then
  begin
    SoftImg.Canvas.MoveTo(OffSet + 12, 1);
    SoftImg.Canvas.LineTo(OffSet + 104, 1);
    SoftImg.Canvas.LineTo(OffSet + 104, 90);
    SoftImg.Canvas.LineTo(OffSet + 75, 90);
    SoftImg.Canvas.LineTo(OffSet + 75, 120);
    SoftImg.Canvas.LineTo(OffSet + 44, 120);
    SoftImg.Canvas.LineTo(OffSet + 44, 90);
    SoftImg.Canvas.LineTo(OffSet + 12, 90);
    SoftImg.Canvas.LineTo(OffSet + 12, 2);
    SoftImg.Canvas.LineTo(OffSet + 103, 2);
    SoftImg.Canvas.LineTo(OffSet + 103, 89);
    SoftImg.Canvas.LineTo(OffSet + 74, 89);
    SoftImg.Canvas.LineTo(OffSet + 74, 119);
    SoftImg.Canvas.LineTo(OffSet + 45, 119);
    SoftImg.Canvas.LineTo(OffSet + 45, 89);
    SoftImg.Canvas.LineTo(OffSet + 13, 89);
    SoftImg.Canvas.LineTo(OffSet + 13, 2);
    SoftImg.Canvas.MoveTo(OffSet + 12, 50);
    SoftImg.Canvas.LineTo(OffSet - 5, 50);
    SoftImg.Canvas.MoveTo(OffSet + 12, 49);
    SoftImg.Canvas.LineTo(OffSet - 5, 49);
    SoftImg.Canvas.TextOut(OffSet - 5 - SoftImg.Canvas.TextWidth('Station 0..9'), 50 - SoftImg.Canvas.TextHeight('A') div 2, 'Station 0..9');
    DrawRect(SoftImg.Canvas, OffSet + 14, 95, OffSet + 43, 121, MORETVOPT[9], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 55, 155, OffSet + 96, 183, MORETVOPT[25], OffSet + 160, 123);
    //DrawRect(SoftImg.Canvas, OffSet + 27, 182, OffSet + 54, 224, 'Line-in - Vol -', OffSet - 5);
    //DrawRect(SoftImg.Canvas, OffSet + 63, 192, OffSet + 88, 215, 'Line-in - Mute', OffSet + 160, 184);
    //DrawRect(SoftImg.Canvas, OffSet + 97, 187, OffSet + 124, 224, 'Line-in - Vol +', OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 224, OffSet + 96, 252, MORETVOPT[26], OffSet + 160, 284);
  end
  else if SoftsLb.Items[SoftsLb.ItemIndex] = KTVStr then
  begin
    SoftImg.Canvas.MoveTo(OffSet + 12, 1);
    SoftImg.Canvas.LineTo(OffSet + 104, 1);
    SoftImg.Canvas.LineTo(OffSet + 104, 90);
    SoftImg.Canvas.LineTo(OffSet + 75, 90);
    SoftImg.Canvas.LineTo(OffSet + 75, 120);
    SoftImg.Canvas.LineTo(OffSet + 44, 120);
    SoftImg.Canvas.LineTo(OffSet + 44, 90);
    SoftImg.Canvas.LineTo(OffSet + 12, 90);
    SoftImg.Canvas.LineTo(OffSet + 12, 2);
    SoftImg.Canvas.LineTo(OffSet + 103, 2);
    SoftImg.Canvas.LineTo(OffSet + 103, 89);
    SoftImg.Canvas.LineTo(OffSet + 74, 89);
    SoftImg.Canvas.LineTo(OffSet + 74, 119);
    SoftImg.Canvas.LineTo(OffSet + 45, 119);
    SoftImg.Canvas.LineTo(OffSet + 45, 89);
    SoftImg.Canvas.LineTo(OffSet + 13, 89);
    SoftImg.Canvas.LineTo(OffSet + 13, 2);
    SoftImg.Canvas.MoveTo(OffSet + 12, 50);
    SoftImg.Canvas.LineTo(OffSet - 5, 50);
    SoftImg.Canvas.MoveTo(OffSet + 12, 49);
    SoftImg.Canvas.LineTo(OffSet - 5, 49);
    SoftImg.Canvas.TextOut(OffSet - 5 - SoftImg.Canvas.TextWidth('Channel 0..9'), 50 - SoftImg.Canvas.TextHeight('A') div 2, 'Channel 0..9');
    DrawRect(SoftImg.Canvas, OffSet + 14, 95, OffSet + 43, 121, KTVOPT[24], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 55, 155, OffSet + 96, 183, KTVOPT[14], OffSet + 160, 123);
    DrawRect(SoftImg.Canvas, OffSet + 27, 182, OffSet + 54, 224, KTVOPT[26], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 63, 192, OffSet + 88, 215, KTVOPT[35], OffSet + 160, 184);
    DrawRect(SoftImg.Canvas, OffSet + 97, 187, OffSet + 124, 224, KTVOPT[27], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 224, OffSet + 96, 252, KTVOPT[15], OffSet + 160, 284);
  end
  else if (SoftsLb.Items[SoftsLb.ItemIndex] = Winamp2Str) or (SoftsLb.Items[SoftsLb.ItemIndex] = Winamp3Str) or (SoftsLb.Items[SoftsLb.ItemIndex] = Winamp5Str) then
  begin
    DrawRect(SoftImg.Canvas, OffSet + 17, 252, OffSet + 41, 282, WINAMPOPT[0], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 79, 252, OffSet + 103, 282, WINAMPOPT[2], OffSet + 160, 225);
    DrawRect(SoftImg.Canvas, OffSet + 110, 252, OffSet + 134, 282, WINAMPOPT[4], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 286, OffSet + 41, 315, WINAMPOPT[5], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 48, 286, OffSet + 72, 315, WINAMPOPT[1], OffSet - 5, 350);
    DrawRect(SoftImg.Canvas, OffSet + 79, 286, OffSet + 103, 315, WINAMPOPT[3], OffSet + 160, 350);
    DrawRect(SoftImg.Canvas, OffSet + 110, 286, OffSet + 134, 315, WINAMPOPT[6], OffSet + 160);
  end
  else if SoftsLb.Items[SoftsLb.ItemIndex] = WMPStr then
  begin
    DrawRect(SoftImg.Canvas, OffSet + 14, 95, OffSet + 43, 121, WMPOPT[11], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 17, 252, OffSet + 41, 282, WMPOPT[2], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 79, 252, OffSet + 103, 282, WMPOPT[0], OffSet + 160, 225);
    DrawRect(SoftImg.Canvas, OffSet + 110, 252, OffSet + 134, 282, WMPOPT[3], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 286, OffSet + 41, 315, WMPOPT[4], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 48, 286, OffSet + 72, 315, WMPOPT[0], OffSet - 5, 350);
    DrawRect(SoftImg.Canvas, OffSet + 79, 286, OffSet + 103, 315, WMPOPT[1], OffSet + 160, 350);
    DrawRect(SoftImg.Canvas, OffSet + 110, 286, OffSet + 134, 315, WMPOPT[5], OffSet + 160);
  end
  else if SoftsLb.Items[SoftsLb.ItemIndex] = BSPlayerStr then
  begin
    DrawRect(SoftImg.Canvas, OffSet + 14, 95, OffSet + 43, 121, BSPLAYOPT[8], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 78, 90, OffSet + 103, 120, BSPLAYOPT[9], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 108, 126, OffSet + 134, 149, BSPLAYOPT[29], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 108, 155, OffSet + 135, 178, BSPLAYOPT[30], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 155, OffSet + 96, 183, BSPLAYOPT[0], OffSet + 160, 123);
    DrawRect(SoftImg.Canvas, OffSet + 27, 182, OffSet + 54, 224, BSPLAYOPT[2], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 63, 192, OffSet + 88, 215, BSPLAYOPT[14], OffSet + 160, 184);
    DrawRect(SoftImg.Canvas, OffSet + 97, 187, OffSet + 124, 224, BSPLAYOPT[3], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 224, OffSet + 90, 252, BSPLAYOPT[1], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 110, 230, OffSet + 134, 252, BSPLAYOPT[38], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 253, OffSet + 41, 282, BSPLAYOPT[12], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 79, 253, OffSet + 103, 282, BSPLAYOPT[14], OffSet + 160, 225);
    DrawRect(SoftImg.Canvas, OffSet + 110, 253, OffSet + 134, 282, BSPLAYOPT[16], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 286, OffSet + 41, 315, BSPLAYOPT[17], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 48, 286, OffSet + 72, 315, BSPLAYOPT[13], OffSet - 5, 350);
    DrawRect(SoftImg.Canvas, OffSet + 79, 286, OffSet + 103, 315, BSPLAYOPT[15], OffSet + 160, 350);
    DrawRect(SoftImg.Canvas, OffSet + 110, 286, OffSet + 134, 315, BSPLAYOPT[18], OffSet + 160);
  end
  else if SoftsLb.Items[SoftsLb.ItemIndex] = PowerDVDStr then
  begin
    DrawRect(SoftImg.Canvas, OffSet + 14, 95, OffSet + 43, 121, PDVDOPT[20], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 108, 126, OffSet + 134, 149, PDVDOPT[17], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 108, 155, OffSet + 135, 178, PDVDOPT[18], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 155, OffSet + 96, 183, PDVDOPT[7], OffSet + 160, 123);
    DrawRect(SoftImg.Canvas, OffSet + 27, 182, OffSet + 54, 224, PDVDOPT[5], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 63, 192, OffSet + 88, 215, PDVDOPT[1], OffSet + 160, 184);
    DrawRect(SoftImg.Canvas, OffSet + 97, 187, OffSet + 124, 224, PDVDOPT[6], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 224, OffSet + 90, 252, PDVDOPT[9], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 225, OffSet + 41, 252, PDVDOPT[19], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 17, 254, OffSet + 41, 282, PDVDOPT[3], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 79, 260, OffSet + 103, 282, PDVDOPT[1], OffSet + 160, 250);
    DrawRect(SoftImg.Canvas, OffSet + 110, 254, OffSet + 134, 282, PDVDOPT[4], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 286, OffSet + 41, 315, PDVDOPT[5], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 48, 286, OffSet + 72, 315, PDVDOPT[0], OffSet - 5, 350);
    DrawRect(SoftImg.Canvas, OffSet + 79, 286, OffSet + 103, 315, PDVDOPT[2], OffSet + 160, 350);
    DrawRect(SoftImg.Canvas, OffSet + 110, 286, OffSet + 134, 315, PDVDOPT[6], OffSet + 160);
  end
  else if SoftsLb.Items[SoftsLb.ItemIndex] = WinSTBStr then
  begin
    SoftImg.Canvas.MoveTo(OffSet + 12, 1);
    SoftImg.Canvas.LineTo(OffSet + 104, 1);
    SoftImg.Canvas.LineTo(OffSet + 104, 90);
    SoftImg.Canvas.LineTo(OffSet + 75, 90);
    SoftImg.Canvas.LineTo(OffSet + 75, 120);
    SoftImg.Canvas.LineTo(OffSet + 44, 120);
    SoftImg.Canvas.LineTo(OffSet + 44, 90);
    SoftImg.Canvas.LineTo(OffSet + 12, 90);
    SoftImg.Canvas.LineTo(OffSet + 12, 2);
    SoftImg.Canvas.LineTo(OffSet + 103, 2);
    SoftImg.Canvas.LineTo(OffSet + 103, 89);
    SoftImg.Canvas.LineTo(OffSet + 74, 89);
    SoftImg.Canvas.LineTo(OffSet + 74, 119);
    SoftImg.Canvas.LineTo(OffSet + 45, 119);
    SoftImg.Canvas.LineTo(OffSet + 45, 89);
    SoftImg.Canvas.LineTo(OffSet + 13, 89);
    SoftImg.Canvas.LineTo(OffSet + 13, 2);
    SoftImg.Canvas.MoveTo(OffSet + 12, 50);
    SoftImg.Canvas.LineTo(OffSet - 5, 50);
    SoftImg.Canvas.MoveTo(OffSet + 12, 49);
    SoftImg.Canvas.LineTo(OffSet - 5, 49);
    SoftImg.Canvas.TextOut(OffSet - 5 - SoftImg.Canvas.TextWidth('Channel 0..9'), 50 - SoftImg.Canvas.TextHeight('A') div 2, 'Channel 0..9');
    DrawRect(SoftImg.Canvas, OffSet + 108, 126, OffSet + 134, 149, WINSTBOPT[24], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 108, 155, OffSet + 135, 178, WINSTBOPT[25], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 15, 121, OffSet + 41, 149, WINSTBOPT[22], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 15, 150, OffSet + 43, 178, WINSTBOPT[23], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 55, 155, OffSet + 96, 183, WINSTBOPT[17], OffSet + 160, 123);
    DrawRect(SoftImg.Canvas, OffSet + 27, 182, OffSet + 54, 224, WINSTBOPT[19], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 63, 192, OffSet + 88, 215, WINSTBOPT[21], OffSet + 160, 184);
    DrawRect(SoftImg.Canvas, OffSet + 97, 187, OffSet + 124, 224, WINSTBOPT[20], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 55, 224, OffSet + 96, 252, WINSTBOPT[18], OffSet + 160, 284);
    DrawRect(SoftImg.Canvas, OffSet + 17, 225, OffSet + 41, 252, WINSTBOPT[16], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 110, 225, OffSet + 134, 252, WINSTBOPT[14], OffSet + 160);
    DrawRect(SoftImg.Canvas, OffSet + 17, 253, OffSet + 41, 282, WINSTBOPT[15], OffSet - 5);
    DrawRect(SoftImg.Canvas, OffSet + 107, 67, OffSet + 141, 92, WINSTBOPT[26], OffSet + 160);
  end
  {else if SoftsLb.Items[SoftsLb.ItemIndex] = AnotherProgStr then
  begin
    DrawRect(DefaultImg.Canvas, OffSet + x1, y1, OffSet + x2, y2, 'Text', x3, (y3));
  end};
end;

//------------------------------------------------------------------------------

procedure TWizardForm.SoftsLbKeyPress(Sender: TObject;
  var Key: Char);
begin
  SoftsLbClick(Sender);
end;

//------------------------------------------------------------------------------

procedure TWizardForm.MoveBtnClick(Sender: TObject);
var
  Index: Integer;
  TmpStr: string;
  TmpBool: Boolean;
begin
  if (SoftsLb.ItemIndex > 0) and (Sender = MoveUpBtn) then
  begin
    Index := SoftsLb.ItemIndex;
    TmpStr := SoftsLb.Items[Index];
    TmpBool := SoftsLb.Checked[Index];
    SoftsLb.Items[Index] := SoftsLb.Items[Index - 1];
    SoftsLb.Checked[Index] := SoftsLb.Checked[Index - 1];
    SoftsLb.Items[Index - 1] := TmpStr;
    SoftsLb.Checked[Index - 1] := TmpBool;
    SoftsLb.ItemIndex := Index - 1;
  end
  else if (SoftsLb.ItemIndex > -1) and (SoftsLb.ItemIndex < SoftsLb.Items.Count - 1) and (Sender = MoveDownBtn) then
  begin
    Index := SoftsLb.ItemIndex;
    TmpStr := SoftsLb.Items[Index];
    TmpBool := SoftsLb.Checked[Index];
    SoftsLb.Items[Index] := SoftsLb.Items[Index + 1];
    SoftsLb.Checked[Index] := SoftsLb.Checked[Index + 1];
    SoftsLb.Items[Index + 1] := TmpStr;
    SoftsLb.Checked[Index + 1] := TmpBool;
    SoftsLb.ItemIndex := Index + 1;
  end;
end;

//------------------------------------------------------------------------------

procedure TWizardForm.Label1Click(Sender: TObject);
begin
  ShellExecute(0, 'open', 'mailto:maxxdelphisite@free.fr', nil, nil, SW_SHOWNORMAL);
end;

//------------------------------------------------------------------------------

procedure TWizardForm.LanguageComboChange(Sender: TObject);
begin
  ApplyLanguage(LanguageCombo.Items[LanguageCombo.ItemIndex]);
end;

//------------------------------------------------------------------------------

end.

